%%%%%%%%%%%%%%%%%%%%%
%4.get_KCcopies
%	-input: .koCov files, MCS.mat
%	-output: KCcopies.mat
 %%%%%%%%%%%%%%%%%%%%%

clear all

%% SET FILTERS
filter_unmappable_genomes=1; %C

%% SET DIRS
%koCovDIR='C:\sharon\lab\StrainVariation\DATA\koCov\';
koCovDIR='M:/PROJECTS/StrainVariation_SG/BWA/koCov/';

if filter_unmappable_genomes
    inDIR = 'gFilter\';
else
    inDIR = 'gNoFilter\';
end

koCovDIR = [koCovDIR inDIR];

%% get MCS

load([inDIR '/MCS.mat'])
KCScopies.samples=MCS.samples;
KCScopies.sampleClass=MCS.sampleClass;
KCScopies.clusters=MCS.clusters;

%% get MASTERLISTS of KOs [4690x1] 
kos=[];
for ii = 1:length(KCScopies.samples)
    fid = fopen([koCovDIR MCS.samples{ii} '.merged.bam.koCov']);
    F=textscan(fid,'%s',1,'delimiter','\t');
    F=textscan(fid,'%s%s%f','delimiter',',');
    fclose(fid);
    kos = union(kos,F{2});
end
KCScopies.kos=kos; clear kos

%% GET KO NAMES and PWs
load KOinfo_8_6_2012
load ko_pw_map_8_6_2012
load pwinfo_8_6_2012

[c ik] = ismember(KCScopies.kos,KO.id);
KCScopies.koNames=KO.name(ik);

[c ip] = ismember(KCScopies.kos,kos);
koPWs=cell(length(KCScopies.kos),1);
for ii=1:length(c)
    if c(ii)
     p=strcat(PW.name(ismember(PW.id,pws(ko_map(ip(ii),:)>0))),',');
     koPWs{ii,1}=strcat(p{:});
    end
end
KCScopies.koPWs=koPWs;

%% READ IN SAMPLES [{clusters} {kos} {cov}]
MCS=MCS.mcs;
KCScopies.vals=zeros(length(KCScopies.clusters),length(KCScopies.kos),length(KCScopies.samples));
for ii = 1:length(KCScopies.samples)
    
    %% find 'present' clusters
   fid = fopen([koCovDIR KCScopies.samples{ii} '.merged.bam.koCov']);
    F=textscan(fid,'%s',1);
    F=textscan(fid,'%s%s%f','delimiter',',');
    fclose(fid);
    
    %% get index of clusters and KOs
    [k kIX] = ismember(F{2},KCScopies.kos);
    [c cIX] = ismember(F{1},KCScopies.clusters);

    %% get KO copies (divide KOcov by clustCopies) [101x4614]
    for cc=1:length(KCScopies.clusters)
        %% get CLUSTER COPIES (avg of marker cov)  [101x1]
            index=kIX(cIX==cc);
            vals=F{3}(cIX==cc)/MCS(cc,ii);
            KCScopies.vals(cc,index,ii)=vals;
    end

end

