#!/usr/bin/perl -w
########################
use lib '/net/gs/vol1/home/greensi/perl/General';
require "download_file_from_FTP.pl";
require "MergeFiles.pl";
###########################
## SET shortcuts
$LAB='/net/borenstein/vol1';

###########################
## GET PARAMETERS
##############################
$infile = shift (@ARGV);
open(INFILE, "$infile") or die "Kozyol cannot read $infile!\n";
$line=<INFILE>; chomp($line); ($v, $SAMPLE_DIR)=split(/\t/,$line); print "sample dir: $SAMPLE_DIR\n";
$line=<INFILE>; chomp($line); ($v, $FTP_DIR)=split(/\t/,$line);print "ftp dir: $FTP_DIR\n";
$line=<INFILE>; chomp($line); ($v, $fileType)=split(/\t/,$line);print "file type: $fileType\n";
#$line=<INFILE>; chomp($line); ($v, $RefGenomes)=split(/\t/,$line);
#$line=<INFILE>; chomp($line); ($v, $BWA_OUTPUT_DIR)=split(/\t/,$line);
close(INFILE);

#############################
## GET BATCHFILE
##########################
$infile = shift (@ARGV);
open(INFILE, "$infile") or die "Kozyol cannot read $infile!\n";
($sample,$rest) = split(/\t/,<INFILE>);
print "$sample:";
@to_download = split(/\|/,$rest);
@fastqs=();
$fileCt=0;
foreach $file (@to_download)
{

	if (scalar @to_download >1)
	{	$fileCt++; 	$saveas_file = $SAMPLE_DIR . $sample . "_" . $fileCt . ".$fileType";	}
	else
	{	$saveas_file = $SAMPLE_DIR . $sample . ".$fileType";		}
	if (not -e $saveas_file)
	{	print "downloading $file...";
		&download_from_ftp($FTP_DIR,$file,$saveas_file);
		print "finished\n";
	}
	else { print "$file already downloaded\n";}

	###############################
	## IF SRA, CONVERT TO FASTQ
	#############################
	if ($fileType eq "sra")
	{	print "converting to fastq...";
		`$LAB/PROGRAMS/sratoolkit.2.3.5-2-centos_linux64/bin/fastq-dump  -O /tmp/ --split-3 $saveas_file`;
		print  "finished\n";
	}
	#########################
	##IF bz2, UNZIP FILE
	########################
	if ($fileType eq "fastq.bz2")
	{	print "unzipping...";
		system('bunzip2', $saveas_file);
		if ($saveas_file =~ m/bz2/)
		{	$saveas_file =~ s/.bz2//;	}
		push @fastqs, $saveas_file;
	}
}
###########################
## IF MULTIPLE FILES, MERGE THEM ## FIX THIS!
#########################
if (scalar @fastqs >1)
{	print "merging...";
	&merge_files(@fastqs,"\/tmp\/$sample.fastq");
	##########################################
	### REZIP INDIVIDUAL FASTQs
	print "re-zipping files...\n";
	foreach $file (@fastqs)
	{	system('bzip2', $file);	print "$file\n";}
}

die;