#!/usr/bin/perl -w
#BWAPIPELINE1_run_bwa.pl
#### downloads a metagenomic short read file for a metahit sample and runs BWA to align it to a set of reference genomes (contigs)
#### outputs a .bam file with alignments

###################################################
## SET shortcuts
#$LAB='/net/borenstein/vol1';

###########################
## GET PARAMETERS
##############################
$infile = shift (@ARGV);
open(INFILE, "$infile") or die "Kozyol cannot read $infile!\n";
$line=<INFILE>; chomp($line); ($v, $SAMPLE_DIR)=split(/\t/,$line); print "sample dir: $SAMPLE_DIR\n";
$line=<INFILE>; chomp($line); ($v, $FTP_DIR)=split(/\t/,$line);print "ftp dir: $FTP_DIR\n";
$line=<INFILE>; chomp($line); ($v, $fileType)=split(/\t/,$line);print "file type: $fileType\n";
$line=<INFILE>; chomp($line); ($v, $RefGenomes)=split(/\t/,$line); print "ref genomes: $RefGenomes|";
$line=<INFILE>; chomp($line); ($v, $BWA_OUTPUT_DIR)=split(/\t/,$line);print " bam output dir: $BWA_OUTPUT_DIR\n";
close(INFILE);

#############################
## GET BATCHFILE
##########################
$sample = shift (@ARGV);
#$infile = shift (@ARGV);
#open(INFILE2, "$infile") or die "Kozyol cannot read $infile!\n";
#($sample,$rest) = split(/\t/,<INFILE2>);
#print "$sample:";

##########################################
### ALIGN MERGED FASTQ TO REFGENOMES WITH BWA
#$sampleFWD= '/tmp/ . $sample . '_1.fastq' ;
$sampleFWD= "$SAMPLE_DIR/$sample.simReads.fasta" ;
print "aligning...";
`perl perl/General/run_bwa.pl $sampleFWD $RefGenomes 5 75`;

print "copying  $sampleFWD.bam to $BWA_OUTPUT_DIR\n";
`cat $sampleFWD.bam > $BWA_OUTPUT_DIR/$sample.bam`;
#`cat $sample.fastq.bam > $BWA_OUTPUT_DIR/$sample.bam`;

##$HOME/Programs/bwa-0.6.2/bwa aln -n 3 -t 4 $RefGenomes $sample.merged.fastq \> $BWA_OUTPUT_DIR$sample.merged.sai`;
##$HOME/Programs/bwa-0.6.2/bwa samse -n 100 $RefGenomes $BWA_OUTPUT_DIR$sample.merged.sai $sample.merged.fastq \> $BWA_OUTPUT_DIR$sample.merged.sam`;

##########################################
### ERASE THE MERGED FASTQ AND SCRATCH BAM FROM HOME DIR
#print "erasing intermediate files\n";
#system('rm','-f', "$sampleFWD");
system('rm','-f', "$sampleFWD.bam");
print "FINISHED. file output to $BWA_OUTPUT_DIR/$sample.bam\n";

##########################################
### CONVERT THE SAM FILE TO A BAM FILE
#`$HOME/Programs/samtools-0.1.18/samtools view -bS $BWA_OUTPUT_DIR$sample.merged.sam \> $BWA_OUTPUT_DIR$sample.merged.bam`;

##########################################
### REMOVE THE SAM FILE
#system('rm','-f', "$BWA_OUTPUT_DIR$sample.merged.sam");


die;
