#!/usr/bin/perl -w
use Net::FTP;

## downloads complete genomes from NCBI according to a supplied list of taxonIDs

###READ IN A LIST OF TAXON IDS, AND AN FTP ADDRESS
###FOR EACH FOLDER IN FTP
###DOWNLOAD EACH .RTP FILE (not .rtp.tgz!), LOOK INSIDE AT TAXON ID, THEN REMOVE .RPT
### IF TAXON ID IS ON THE LIST, DOWNLOAD .FNA FILE
### SAVE AS taxID.fileName.fasta
### gzip it, if not already

#######################################################
###          FILES                                 ###
######################################################
## NCBI GENBANK ftp site
$taxID_list = 'Projects/SG_SINGLEGENOMES/DATA/landscape/LANDSCAPE.refGenomes.taxID.n261.txt'; ##list of taxon IDs
$ftp = 'ftp.ncbi.nih.gov/genbank/genomes/Bacteria';  
$fasta_outDir = 'RefSets/LANDSCAPE_REF_GENOMES/NCBI_GENBANK/fastas/';
$gene_outDir = 'RefSets/LANDSCAPE_REF_GENOMES/NCBI_GENBANK/gene_calls/';

## NCBI BACTERIA_DRAFT ftp site
#$taxID_list = 'Projects/SG_SINGLEGENOMES/DATA/landscape/LANDSCAPE.refGenomes_bacteria_DRAFT.taxID.n127.txt'; ##list of taxon IDs
#$ftp = 'ftp.ncbi.nih.gov/genomes/Bacteria_DRAFT';  
#$fasta_outDir = 'RefSets/LANDSCAPE_REF_GENOMES/NCBI_BACTERIA_DRAFT/fastas/';
#$gene_outDir = 'RefSets/LANDSCAPE_REF_GENOMES/NCBI_BACTERIA_DRAFT/gene_calls/';

#####################################################
# --- --- Get a list of all desired species --- --- #
$nof_taxIDs = 0;
print "getting records for: \n";
%h_TaxIDs=();
open (FH, "$taxID_list") or die "Cannot open $taxID_list for reading.\n";
while(<FH>) {
  $line=$_; chomp($line); 
  $h_TaxIDs{$line}=0;
  print "$line|";
  $nof_taxIDs++;
}
close(FH);
print "\n";
################################################
##list folders in the ftp directory
print "logging into $ftp ...\n";
($ftp_host, $ftp_dir) = ($ftp =~ m/([^\/]+)(\/.+)/); 
$ftp = Net::FTP->new($ftp_host) or die "cant connect to $@!\n";
$ftp->login("anonymous", 'greensi@uw.edu') or die "cant login ", $ftp->message;
$ftp->cwd($ftp_dir) or die "cant change dir! ", $ftp->message;
@ftp_folders = $ftp->ls();
$ftp->binary();

###################################################################
## open each rpt file and see if it corresponds to a taxa of interest
foreach $spc_folder (@ftp_folders)
{
	@files = $ftp->ls($spc_folder . "\/*.rpt");
	
	foreach $rpt_file (@files)
	{	
		$temp_rpt = $ftp->get($rpt_file, "temp.rpt") or die "get failed ", $ftp->message;
		($acc) = ($rpt_file =~ m/([^\\\/]+).rpt$/);
		open (FH, "$temp_rpt") or die "Cannot open $temp_rpt for reading.\n";
		$line = <FH>; chomp $line;
		while (! ($line =~ m/Taxid/))
		{	$line = <FH>;	chomp $line;		}
		close(FH);
		($rest,$taxid) = split(/: /,$line);
		#print "$taxid|";

#####################################		
#### if it does, download the fasta and ptt file
		if (exists $h_TaxIDs{$taxid})
		{	
			$numFound++;print "$numFound :";
			@fastas = $ftp->ls($spc_folder . "\/$acc*.fna*");
			foreach $fasta_file (@fastas)
			{	($filename) = ($fasta_file =~ m/([^\/]+)$/);
				$new_fasta = $fasta_outDir . $taxid . "_" . $filename;
				$ftp->get($fasta_file, $new_fasta) or die "get failed ", $ftp->message;
				if ( $new_fasta !~ m/.tgz$/)
				{	system('tar','czf',$new_fasta . ".tgz", $new_fasta); $new_fasta = $new_fasta . ".tgz";}
				print " $new_fasta\n";	
				$h_TaxIDs{$taxid}++;
				($gene_file = $fasta_file) =~ s/fna/ptt/;
				($new_gene = $new_fasta) =~ s/fna/ptt/;
				$new_gene =~ s/$fasta_outDir/$gene_outDir/;
				$ftp->get($gene_file, $new_gene) or die "get failed ", $ftp->message;
				print " $new_gene\n";	
			}
		}
	}
}
$ftp->quit;
##########################################
#### print file counts to log file

open (FH, ">$fasta_outDir" . "log.txt") or die "Cannot open logfile for writing.\n";
print FH "TAXID\tNOF_FILES\n";
foreach $taxid (sort keys %h_TaxIDs)
{	print FH "$taxid\t$h_TaxIDs{$taxid}\n";	}
close(FH);
	
die;
# --- --- --- --- --- -- -- --- --- --- --- --- #


