# batch job script (LANDSCAPE_metahit_bwa.sh)
#
# Use the bash shell to interpret this job script
#$ -S /bin/bash
#
# Remove one # to send an e-mail to the address 
# specified in .sge_request when this job ends.
#$ -m e
#
# Remove one # to only submit this job to nodes
# that have at least 8GB of RAM free.
#$ -l mem_free=8.0G
#$ -pe serial 4-4
GSITSHOST=`/bin/hostname`
GSITSPWD=`/bin/pwd`
GSITSDATE=`/bin/date`
echo "**** JOB STARTED ON $GSITSHOST AT $GSITSDATE"
echo "**** JOB RUNNING IN $GSITSPWD"
echo "----------------------------------------------"
#shell script to download metahit metagenomic samples as fastq files and BWA them against the LANDSCAPE ref genomes 
LAB_PATH="/net/borenstein/vol1"
genbankTaxids=$LAB/PROJECTS/StrainVariation_SG/DATA/REVISION/new_ref_genomes/newGenomes.GENBANK.taxids
draftTaxids=$LAB/PROJECTS/StrainVariation_SG/DATA/REVISION/new_ref_genomes/newGenomes.DRAFT.taxids
infoFile=RefSets/LANDSCAPE_REF_GENOMES/REVISION.newGenomes.taxInfo
mergedNucFasta=RefSets/LANDSCAPE_REF_GENOMES/REVISION.newGenomes.nuc.fasta
mergedProtFasta=RefSets/LANDSCAPE_REF_GENOMES/REVISION.newGenomes.prot.fasta

echo "getting taxon info..."
perl $LAB/PROJECTS/StrainVariation_SG/CODE/perl/1_DOWNLOAD_REF_GENOMES/STRAINVAR2_get_taxon_info.pl $infoFile NCBI_GENBANK $genbankTaxids NCBI_BACTERIA_DRAFT $draftTaxids

#echo "merging nucleotide fastas..."
#perl $LAB/PROJECTS/StrainVariation_SG/CODE/perl/1_DOWNLOAD_REF_GENOMES/STRAINVAR3_merge_contigs_by_taxon.pl $mergedNucFasta NCBI_GENBANK $genbankTaxids NCBI_BACTERIA_DRAFT $draftTaxids

#echo "downloading protein fastas..."
#perl $LAB/PROJECTS/StrainVariation_SG/CODE/perl/2_ANNOTATE_GENOMES/STRAINVAR1_getNCBI_protein_fastas.pl

#echo "merging protein seqs..."
#perl $LAB/PROJECTS/StrainVariation_SG/CODE/perl/2_ANNOTATE_GENOMES/STRAINVAR2_merge_protein_seqs.pl $mergedProtFasta RefSets/LANDSCAPE_REF_GENOMES/REVISION.newGenomes.nuc.fasta.headers NCBI_GENBANK NCBI_BACTERIA_DRAFT

## Put the current date into a variable and report it before we exit.
GSITSENDDATE=`/bin/date`
echo "----------------------------------------------"
echo "**** JOB DONE, EXITING 0 AT $GSITSENDDATE"
##
## Exit with return code 0, otherwise the job would exit with the 
## return code of the failed ls command.
exit 0
##
########################################
